use strict;
use warnings;
use URI::Escape;
use LWP::UserAgent;  
use HTTP::Request;
use XML::LibXML;

my $type        = $ARGV[0]; 
my $hostname    = $ARGV[1]; 
my $httpskey    = $ARGV[2]; 

my $command;
if($type eq "arp")          {$command = "<show><arp><entry name='all'/></arp></show>";}
elsif($type eq "userid")    {$command = "<show><user><ip-user-mapping><all><option>count</option></all></ip-user-mapping></user></show>";}
else                        {$command = "<show><session><info></info></session></show>";}
 
my $urlcommand	= uri_escape($command);
my $URL		= 'https://'.$hostname.'/api/?type=op&key='.$httpskey.'&cmd='.$urlcommand;

my $xml_string;

my $ua = LWP::UserAgent->new(ssl_opts => { verify_hostname => 0 });
my $header = HTTP::Request->new(GET => $URL);  
my $request = HTTP::Request->new('GET', $URL, $header);  
my $response = $ua->request($request);  

if ($response->is_success){  
        $xml_string = $response->content;
}
elsif ($response->is_error){  
        print "Error:$URL\n";  
        print $response->error_as_HTML;  
}

my $parser = XML::LibXML->new();
my $xmlfile = XML::LibXML->load_xml(string => $xml_string);

if($type eq "arp") {
	my($node) = $xmlfile->findnodes('/response/result/max');
	my $max=$node->textContent();
	($node) = $xmlfile->findnodes('/response/result/total');
	my $total=$node->textContent();
	print "max:".$max." total:".$total."\n";
}
elsif($type eq "userid") {
	my($node) = $xmlfile->findnodes('/response/result');
	my $userids=$node->textContent();
	$userids =~ s/"users"/""/g;
	my $userid = substr $userids, 7, length($userids)-15, "";
	print "userids:".$userid."\n";
}
elsif($type eq "sessions") {
	my($node) = $xmlfile->findnodes('/response/result/num-max');
	my $max=$node->textContent();
	($node) = $xmlfile->findnodes('/response/result/num-active');
	my $active=$node->textContent();
	($node) = $xmlfile->findnodes('/response/result/num-tcp');
	my $tcp=$node->textContent();
	($node) = $xmlfile->findnodes('/response/result/num-udp');
	my $udp=$node->textContent();
	($node) = $xmlfile->findnodes('/response/result/num-icmp');
	my $icmp=$node->textContent();
	print "max:".$max." active:".$active." tcp:".$tcp." udp:".$udp." icmp:".$icmp."\n";
}
else {
	my($node) = $xmlfile->findnodes('/response/result/kbps');
	my $throughput =$node->textContent();
	print "throughput:".$throughput."\n";
}